
{{$A+,B-,D+,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
uses font,database,disutils;
const
breaks:word=0;
segmentt=5;
lines:longint=0;
knlines:longint=0;
var i:word;
{var buf:pbuf;}
instr,labels,subr,done,remove:tset;
info3,info4,info5:pdatainfo;
cref:tcrossref;
leng:tlength;
helpt:text;
seekfile:text;
const seekinst:integer=-1;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure load;
var f:file;
    ff:file of tmapa;
    t:text;
s:word;
p:string[20];
begin
p:=paramstr(1);if p[0]<>#1 then halt;
segment:=byte(p[1])-48;
p:=paramstr(2);if p[0]<>#0 then begin p:='$'+p;val(p,seekinst,s);end;
if (segment>3) then halt;

assign(f,'rom9850.rom');reset(f,1);
buf:=pbuf($a0000000);
getmem(buf,65535);
seek(f,segment*65536);
blockread(f,buf^,32768,s);blockread(f,buf^[32768],32768,s);
close(f);
labels.init;subr.init;instr.init;done.init;remove.init;
assign(ff,'seg'+char(segment+48)+'.tbl');reset(ff);
read(ff,labels.datamapa^,subr.datamapa^);
close(ff);
assign(t,'seg'+char(segment+48)+'.rem');reset(t);
while not eof(t) do
begin
readln(t,s);
remove.wset(s);
end;
close(t);
labels.andnot(remove);
subr.andnot(remove);
instr.andnot(remove);
done.andnot(remove);
if html then begin assign(ff,'seg'+char(segment+48)+'.htt');
reset(ff);read(ff,instr.datamapa^);
close(ff);end else instr.reset;
new(info3,init('seg3.dad'));
new(info4,init('seg4.dad'));
new(info5,init('seg5.dad'));
leng.init('lengths.ins');
assign(seekfile,'seek'+char(segment+48)+'.txt');rewrite(seekfile);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure save;
var ff:file of tmapa;
begin
assign(ff,'seg'+char(segment+48)+'.tbl');rewrite(ff);
write(ff,labels.datamapa^,subr.datamapa^);
close(ff);
if not html then begin assign(ff,'seg'+char(segment+48)+'.htt');
rewrite(ff);
write(ff,instr.datamapa^);
close(ff);
close(seekfile);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pisdata(b:boolean;i:word;var t:text);
{const p4:pbuf=nil;{pbuf($a0000000);}
{const p5:pbuf=nil;}
var f:file;j:word;
begin
if info4^.iscomment(i)then
write(t,#9'; Seg4:"',info4^.getcomment(i),'"')
else if info5^.iscomment(i)then
write(t,#9'; Seg5:"',info5^.getcomment(i),'"')
else if info3^.iscomment(i)then write(t,#9'; Seg3:"',info3^.getcomment(i),'"')
(*{} else if true or b then begin
if p4=nil then begin
getmem(p4,65535);

assign(f,'rom9850.rom');reset(f,1);
j:=filesize(f) shr 16;
seek(f,segmentt shl 16);
blockread(f,p4^,65535,j);
{getmem(p5,65535);seek(f,5*65536);blockread(f,p5^,65535);}
close(f);end;
write(t,#9';Seg',segmentt,':"');for j:=0 to 21 do write(t,char(p4^[i+j]));
{write(t,'"  Seg5:"');for j:=0 to 21 do write(t,char(p5^[i+j]));}
write(t,'"');
end;{*)
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure piscalled(i:word;var t:text);
var p:pinfo;
begin
p:=cref.tabptr(i);
if (p<>nil)and (p^.mode=0)then write(t,#9'; ',p^.s)
else writeln(helpt,i);
if not remove.rset(i) then instr.wset(i);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pisdat(i:word;var t:text);
begin
if not html then write(t,#9'; ',znak[i],' | ',znak[i+256],' | ',znak[i+512]);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure hop(var t:text;var i:longint;j:byte);
var s:word;
c,h:byte;
begin
s:=i-1;h:=j+1;
while j>0 do begin
if instr.rset(i)and not remove.rset(i) then begin
writeln(t,'           Opcode break');
if html then writeln(t,'<P>');
c:=buf^[s];
{leng.change(c,i-s-1);}
inc(breaks);exit;end;
inc(i);dec(j);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure hopnop(var t:text;var i:longint);
var s:word;
begin
s:=0;
repeat
inc(i);inc(s);
until (buf^[i]<>255)or (I>20000)and instr.rset(i);
if s>1 then write(t,s,'x ');
write(t,'nop');
if html then writeln(t,' <P>') else writeln(t);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pisinst(var i:longint;var t:text);
var j,k,c:byte;adr:word;
    s:string[4];
begin
s:=tohex(i,4);
if HTML and instr.rset(i)then write(t,'<A NAME="',s,'">',s,': </A> ')
                         else write(t,s,':'#9);
inc(lines);
c:=buf^[i];
if c=seekinst then writeln(seekfile,tohex(i,4),' ',seekkontext);
if not database.isknown(c) then leng.enabled(false);
if instr.rset(i) then leng.enabled(true);

if c=255 then begin hopnop(t,i);exit;end;

if @instrukce[c]<>nil then
begin
instrukce[c](t,i);inc(knlines);
if database.isjump(c) then piscalled(buf^[i-2]shl 8 or buf^[i-1],t);
if database.isdata(c) then pisdat(buf^[i-1],t);
if database.isadr(c) then pisdata(buf^[i-3]=$7E,buf^[i-2]+buf^[i-1]shl 8,t);
if HTML then writeln(t,' <P>') else writeln(t);
exit;
end;

if database.isknown(c) then
 begin
 write(t,'_s ');
 if c in database.size3 then for k:=0 to 2 do write(t,tohex(buf^[i+k],2),' ');
 if c in database.size2 then for k:=0 to 1 do write(t,tohex(buf^[i+k],2),' ');
 if c in database.size1 then for k:=0 to 0 do write(t,tohex(buf^[i],2),' ');
 write(t,#9';known size');
 inc(i);hop(t,i,k);
if HTML then writeln(t,' <P>') else writeln(t);
exit;
end;

 for k:=0 to leng.length(c) do write(t,tohex(buf^[i+k],2),' ');
 inc(i);hop(t,i,k);write(t,#9';unknown instr.');
 leng.enabled(false);
if HTML then writeln(t,' <P>') else writeln(t);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure writedata(var t,tdata:text;var i,d:longint);
{db|ds|da|a.. size Title}
var db:array[0..1]of char;
s:string;
begin
repeat
readln(tdata,db[0],db[1],d,s);db[0]:=upcase(db[0]);db[1]:=upcase(db[1]);
if db[0]='D' then inc(d,i) else if db[0]<>'A' then
             begin writeln('Fatal error at ',i,' in .dad file');halt;end;
writeln(t,#13#10'Indexed data table: ',s);
if html then writeln(t,'<P>');
write(t,tohex(i,4),': D',db[1],' ');

case db[1] of
'B': while i<d do
     begin
     write(t,tohex(buf^[i],2));inc(i);
     if i<d then if (i and 15 =0)then if html then writeln(t,'<P>'#13#10,tohex(i,4),': DB ')
     else write(t,#13#10,tohex(i,4),': DB ') else write(t,',');
     end;
'S': begin write(t,'"');while i<d do
     begin
     write(t,char(buf^[i]));inc(i);
     if (i and 31 =0)and(d-i>42) then  if html then writeln(t,'<P>'#13#10,tohex(i,4),': DS ')
     else write(t,'"'#13#10,tohex(i,4),': DS "');
     end;write(t,'"');end;
'A': while i<d do
     begin
     write(t,tohex(buf^[i+1] shl 8 or buf^[i],4));inc(i,2);
     piscalled(buf^[i-1]shl 8 or buf^[i-2],t);
     if i<d then  if html then writeln(t,'<P>'#13#10,tohex(i,4),': DA ')
     else write(t,#13#10,tohex(i,4),': DA ');
     end;
end;
readln(tdata,d);
if html then writeln(t,'<P>');
writeln(t);
until d<>i;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dissasm;
var t,ta,tb,tdata:text;
i,d:longint;j:word;
begin
if html then assign(t,'seg'+char(segment+48)+'.htm')
else assign(t,'seg'+char(segment+48)+'.asm');rewrite(t);
assign(ta,'seg'+char(segment+48)+'.exp');rewrite(ta);
assign(tb,'seg'+char(segment+48)+'.loc');rewrite(tb);
assign(helpt,'seg'+char(segment+48)+'.cnt');rewrite(helpt);
assign(tdata,'seg'+char(segment+48)+'.dad');reset(tdata);
i:=0;j:=0;if not eof(tdata) then readln(tdata,d) else d:=-1;
if HTML then begin
writeln(t,'<HTML>'#13#10'<HEAD>');
writeln(t,'<!-- Created by CASIO cfx9850G disassembler version 14 -->');
writeln(t,'<TITLE> Segment ',char(segment+48),' </TITLE>');
writeln(t,'</HEAD>'#13#10'<BODY>'#13#10'<P>');
writeln(t,'<P ALIGN=Center>');
writeln(t,'<FONT COLOR="#ff0000"><BIG><BIG><BIG>CASIO cfx 9850 G ROM full source code');
writeln(t,'</BIG></BIG></BIG></FONT>');
writeln(t,'<P ALIGN=Center>');
writeln(t,'<FONT COLOR="#000000"><BIG><BIG><BIG><BIG><BIG>SEG');
writeln(t,char(segment+48),'</BIG></BIG></BIG></BIG></BIG></FONT>');
writeln(t,'<P ALIGN=Center>');
writeln(t,'<FONT COLOR="#0000ff"><BIG>Created by');
writeln(t,'</BIG></FONT><FONT COLOR="#00ff00"><BIG><BIG>disasm</BIG></BIG></FONT><FONT');
writeln(t,'COLOR="#0000ff"><BIG> version 14 (First HTML version)</BIG></FONT>');
end;
while i<= 65535 do begin
if i=d then writedata(t,tdata,i,d);
if cref.iscomment(i,tb) then cref.getcomment(i,ta,t);
if subr.rset(i)then if html then writeln(t,'<P>'#13#10'Subroutine:<P>') else writeln(t,'Subroutine:');
if labels.rset(i)then if html then writeln(t,'<P>'#13#10'Label:<P>') else writeln(t,'Label:');

if (i-j)>=4096 then begin j:=i;write('.');end;
pisinst(i,t);
end;
if HTML then writeln(t,#13#10'</BODY>'#13#10'</HTML>');

close(t);close(ta);close(tb);close(helpt);close(tdata);
writeln;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
{assign(tmpfile,'pom.txt');append(tmpfile);}
writeln('Loading ROM file...');
load;
cref.init(segment,buf,labels,subr,instr,done);

write('Disassembling to ');
if html then writeln('HTML.')else writeln('TXT.');
dissasm;
writeln(breaks,' broken instructions found');
writeln('Free memory:',maxavail);
writeln('Total lines:',lines);
writeln('Unknown    :',100*(lines-knlines)/lines:3:3,'%');
leng.done('lengths.ins');
save;
{close(tmpfile);}
end.