unit disutils;
interface
type tbuf=array[0..65534]of byte;
     tmapa=array[0..8191]of byte;
     pmapa=^tmapa;
     string40=string[40];
     type string1=string[1];
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     pinfo=^tinfo;
     tinfo=record
          next:pinfo;
          sk:word;
          case mode:byte of
          0:(s:string1);
          1:(adr:word;jump:boolean;)
     end;
ttable=array[0..32766]of word;
pbuf=^tbuf;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function str(i:longint):string;
function tohex(l:longint;s:byte):string;

type tset=object
datamapa:pmapa;
constructor init;
procedure reset;
function wset(i:word):boolean;
function rset(i:word):boolean;
procedure andnot(const rem:tset);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type
pdata=^tdata;
tdata=record
adr:word;
next:pdata;
info:string1;
end;
type
pdatainfo=^tdatainfo;
tdatainfo=object
mapa:tset;
data:pdata;
constructor init(const name:string40);
destructor done;
function iscomment(i:word):boolean;
function getcomment(i:word):string40;
end;

type tcrossref=object
table:array[0..1]of ^ttable;
plabels,psubr,pinstr,pdone:^tset;
buf:pbuf;
constructor init(seg:byte;bf:pbuf;var labels,subr,instr,fertig:tset);
destructor done;
function tabptr(i:word):pinfo;
function iscomment(i:word;var t:text):boolean;
procedure getcomment(i:word;var t,c:text);
procedure crossref;
procedure simplify;
end;

type tlength=object
delky:array[byte]of byte;
chok:boolean;
constructor init(const name:string);
destructor done(const name:string);
function length(i:byte):byte;
procedure enabled(e:boolean);
procedure change(i,j:byte);
end;
const seekkontext:string='';
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
implementation
uses database;
var s:string;
function str(i:longint):string;
var s:string[10];
begin
system.str(i,s);
str:=s;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getmemw(var p:pointer;i:word);
begin
getmem(p,i);
if ofs(p^)<>0 then begin
{write('#');}
freemem(p,i);
getmem(p,i+8);
p:=pointer((longint(nil)+system.seg(p^)+1)shl 16);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure strcpy(var s1:string1;const s2:string);
var i:byte;
begin
for i:=0 to byte(s2[0]) do s1[i]:=s2[i];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function tohex(l:longint;s:byte):string;
const  conv:array[0..15]of char
      =('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var i:byte;
sm:string;
begin
sm:='';
for i:=1 to s do begin
sm:=conv[l and 15]+sm;
l:=l shr 4;
end;
tohex:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
constructor tset.init;
begin
new(datamapa);reset;
end;

procedure tset.reset;
begin
FillChar(datamapa^,8192,0);
end;

function tset.wset(i:word):boolean;
var j:word;
begin
wset:=false;
if rset(i)then exit;
wset:=true;
j:=i and 7;
i:=i shr 3;
datamapa^[i]:=datamapa^[i]or(1 shl j);
end;
function tset.rset(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
rset:=datamapa^[i] and (1 shl j)<>0;
end;
procedure tset.andnot(const rem:tset);
var i:word;
begin
for i:=0 to 8191 do
begin
datamapa^[i]:=datamapa^[i]and not rem.datamapa^[i];
i:=i;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
constructor tdatainfo.init(const name:string40);
var t:text;
p:pdata;
adr:word;
info:string[40];
begin
data:=nil;mapa.init;
assign(t,name);reset(t);
while not eof(t) do begin
readln(t,adr);
readln(t,info);
mapa.wset(adr);
getmem(p,sizeof(tdata)+byte(info[0]));
strcpy(p^.info,info);p^.adr:=adr;
p^.next:=data;
data:=p;
end;
close(t);
end;

destructor tdatainfo.done;
var p:pdata;
begin
end;

function tdatainfo.iscomment(i:word):boolean;
begin
iscomment:=mapa.rset(i)or mapa.rset(i-1)or mapa.rset(i+1);
end;

function tdatainfo.getcomment(i:word):string40;
var p:pdata;
begin
p:=data;s:='';
while p<>nil do begin
if abs(p^.adr-i)<2 then begin s:=p^.info+' '+char(49+p^.adr-i);break;end;
p:=p^.next;
end;
getcomment:=s;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

constructor tlength.init(const name:string);
var f:file;
begin
assign(f,name);reset(f,256);
blockread(f,delky,1);close(f);
chok:=false;
end;

destructor tlength.done(const name:string);
var f:file;
begin
assign(f,name);rewrite(f,256);
blockwrite(f,delky,1);close(f);
end;

function tlength.length(i:byte):byte;
begin
length:=delky[i];
end;

procedure tlength.enabled(e:boolean);
begin
chok:=e;
end;

procedure tlength.change(i,j:byte);
begin
if not chok then exit;
delky[i]:=j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function tcrossref.tabptr(i:word):pinfo;
var p:pinfo;
begin
p:=nil;
p:=pinfo((longint(p)+table[i shr 15]^[i and 32767])shl 16);
tabptr:=p;
end;


constructor tcrossref.init;
var i,j:word;
    p:pinfo;
    info:text;
    s:string;
begin
for i:=0 to 1 do begin
getmem(table[i],65535);FillChar(table[i]^, 65535, 0);
table[i]^[32767-0*i]:=0;
end;
plabels:=@labels;psubr:=@subr;pinstr:=@instr;pdone:=@fertig;buf:=bf;

writeln('Analysing known functions');
assign(info,'seg'+char(seg+48)+'.adr');reset(info);
while not eof(info) do begin
readln(info,i);readln(info,s);
getmemw(pointer(p),sizeof(tinfo)+byte(s[0]));write('.');
p^.mode:=0;p^.sk:=0;
p^.next:=nil;strcpy(p^.s,s);
subr.wset(i);
table[i shr 15]^[i and 32767]:=system.seg(p^);
end;
close(info);
writeln;


writeln('Analysing exported functions from segment ',seg);
for j:=0 to 3 do begin
write('Segment ',j);
assign(info,'seg'+char(j+48)+'.exp');reset(info);
while not eof(info) do begin
readln(info,i);
if i<>seg then begin readln(info);readln(info);continue;end;
readln(info,i);
readln(info,s);
write('.');
if tabptr(i)=nil then begin
getmemw(pointer(p),sizeof(tinfo)+byte(s[0])+2);
p^.mode:=0;p^.sk:=0;
strcpy(p^.s,'F '+s);p^.next:=nil;
table[i shr 15]^[i and 32767]:=system.seg(p^);
end
else {tabptr(i)^.s:=tabptr(i)^.s+','+s};
end;
close(info);

writeln;
end;

writeln('Analysing functions used by segment ',seg);
for i:=0 to 3 do begin
write('Segment ',i);
assign(info,'seg'+char(i+48)+'.loc');reset(info);
while not eof(info) do begin
readln(info,j);j:=j-2;
if (buf^[j]=$D1)and(buf^[j+1]=$20+i) then
begin
write('.');
labels.wset(j);

readln(info,s);
getmemw(pointer(p),sizeof(tinfo)+byte(s[0])+5);
p^.mode:=0;p^.sk:=0;
p^.next:=tabptr(j);strcpy(p^.s,'Seg'+char(buf^[j+1]-$20+48)+'.'+s);
table[j shr 15]^[j and 32767]:=system.seg(p^);
end
else readln(info);
end;
close(info);
writeln;
end;

crossref;
simplify;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tcrossref.crossref;
var b:boolean;
    i,j:word;
    k:byte;

procedure addtbl(i,j:word;l:boolean);
var p,pp:pinfo;
begin
if l then
plabels^.wset(i)
else psubr^.wset(i);
pp:=tabptr(i);p:=pp;
if p<>nil then if p^.mode=0 then exit;
while p<>nil do begin
if p^.mode=1 then if p^.adr=j then exit;
p:=p^.next;
end;
getmemw(pointer(p),10);
with p^ do begin
mode:=1;jump:=l;adr:=j;p^.sk:=65535;end;
p^.next:=pp;
table[i shr 15]^[i and 32767]:=system.seg(p^);
end;



{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
writeln('Creating cross references.');
repeat
b:=false;write('.');
for i:=0 to 65530 do
if (tabptr(i)<>nil) and not pdone^.rset(i) then begin
b:=true;pdone^.wset(i);pinstr^.wset(i);j:=i;

while ((i=j)or(tabptr(j)=nil))and database.isknown(buf^[j])do
begin
if database.isjump(buf^[j]) then
begin
addtbl(buf^[j+1]shl 8 + buf^[j+2],i,buf^[j]<>$8A);inc(j,3);
end
else begin database.name(buf^[j],k);
if (buf^[j]=$9F)or(buf^[j]=$88) then
break;
inc(j,k+1);
end;
end;
end;
until not b;
writeln;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tcrossref.simplify;
var p,pp:pinfo;
i:word;zn:byte;
begin
writeln('Preparing the cross reference database for use.');
repeat
zn:=0;write('.');
for i:=0 to 65535 do
begin
p:=tabptr(i);
while p<>nil do begin
if(p^.mode=1)and(p^.sk=65535)then begin
pp:=tabptr(p^.adr);
while pp<>nil do begin
zn:=1;
if pp^.sk<65535 then begin
p^.sk:=pp^.sk+1;
if pp^.mode=0 then break;

p^.adr:=pp^.adr;p^.jump:=pp^.jump;
if tabptr(pp^.adr)^.mode<>0 then
runerror(255);
break;
end;
pp:=pp^.next;
end;
end;
if p^.mode=1 then p:=p^.next else p:=nil;
end;
end;
until zn=0;
writeln;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
destructor tcrossref.done;
begin
end;

function tcrossref.iscomment(i:word;var t:text):boolean;
var dalsi:pinfo;
j:word;
begin
if i=24338 then
i:=i;
iscomment:=false;
if tabptr(i)<>nil then if tabptr(i)^.sk<6 then iscomment:=true;
{omezeni odkazu na 5}
if i>=$EB50 then
begin
j:=i;
if buf^[i]=255 then if buf^[i+1]=$FF then j:=i+2;
dalsi:=tabptr(buf^[i+1] shl 8 + buf^[i+2]);
if database.isjump(buf^[j]) then
if dalsi<>nil then if dalsi^.mode=0
then  writeln(t,j,#13#10,dalsi^.s);
end;

end;

procedure tcrossref.getcomment(i:word;var t,c:text);
var p,pp:pinfo;
u:word;l:boolean;
begin
p:=tabptr(i);
writeln(c);
while p<>nil do begin
pp:=p;
if p^.mode=0 then
if html then writeln(c,'Function <BIG><BIG>',p^.s,'</BIG></BIG> <P>')else
begin writeln(c,'Function ',p^.s);seekkontext:=p^.s;END
else begin
if p^.sk<6 then begin
 if p^.jump then write(c, 'Label ') else write(c,'Subr.');
 if p^.sk<65535 then write(c,' ['+str(p^.sk)+']: ')
               else write(c,' <Cyclic references>');
 end;
pp:=tabptr(p^.adr);
if pp^.mode<>0 then runerror(254);
writeln(c,pp^.s);seekkontext:=pp^.s;if html then writeln(c,'<P>');
end;
if p^.mode=1 then p:=p^.next else p:=nil;
if i>=$EB50 then
if pp<>nil then if pp^.mode=0 then if buf^[i]=$D1 then writeln(t,buf^[i+1]-$20,#13#10,i+2,#13#10,pp^.s);

end;
end;
end.