{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type tbuf=array[0..65000]of byte;
pbuf=^tbuf;
const segment=2;
tokinfo= (segment =1)or(segment=2);
var t,info:text;i,j,k,l:word;
ch:char;
var buf:pbuf;
b:boolean;
s:string;
instr,labels,subst:array[0..8191]of byte;
const  conv:array[0..15]of char
      =('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function tohex(l:longint;s:byte):string;
var i:byte;
sm:string;
begin
sm:='';
for i:=1 to s do begin
sm:=conv[l and 15]+sm;
l:=l shr 4;
end;
tohex:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure load;
var f:file;
s:word;
begin
for s:=0 to 8191 do labels[s]:=0;subst:=labels;instr:=labels;
assign(f,'rom9850.rom');reset(f,1);
getmem(buf,65535);seek(f,segment*65536);
fillchar(buf^,65535,0);
blockread(f,buf^,65535,s);
close(f);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function settl(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
settl:=labels[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function setts(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
setts:=subst[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function sett(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
sett:=(labels[i] or subst[i])and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function addl(i:word):boolean;
var j:byte;
begin
addl:=false;
if settl(i)then exit;
if not setts(i) then addl:=true;
j:=i and 7;
i:=i shr 3;
labels[i]:=labels[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function adds(i:word):boolean;
var j:byte;
begin
adds:=false;
if setts(i)then exit;
if not settl(i) then adds:=true;
j:=i and 7;
i:=i shr 3;
subst[i]:=subst[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure addi(i:word);
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
instr[i]:=instr[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function setti(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
setti:=instr[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pisinst(var i:word);
const symb:boolean=false;
begin
if setti(i) then if not symb then begin writeln(t);symb:=true;end;
if symb then begin
write(t,tohex(i,4),': ');
case buf^[i] of
$88 :begin writeln(t,'jmp  ',tohex(buf^[i+1]shl 8+buf^[i+2],4));i:=i+2;end;
$8A :begin writeln(t,'call ',tohex(buf^[i+1]shl 8+buf^[i+2],4));i:=i+2;end;
$9F :writeln(t,'ret');
$FF :writeln(t,'nop');
$D1 :begin inc(i);if buf^[i] and 240 <>$20 then runerror;
     writeln(t,'Cseg ',tohex(buf^[i] and 15,2));end;
else begin symb:=false;write(t,tohex(buf^[i],2),' ');end;
end;
exit;end;
symb:=symb or setti(i);
write(t,tohex(buf^[i],2),' ');
if i and 15 =15 then write(t,#13#10,tohex(i+1,4),': ');
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
writeln('Loading ROM file');
load;
writeln('Loading primary table');
if tokinfo then begin
assign(info,'seg'+char(segment+48)+'.adr');reset(info);
while not eof(info) do begin
readln(info,j);readln(info);
addl(j);
end;
close(info);
end;

assign(info,'seg'+char(segment+48)+'.map');reset(info);
while not eof(info) do begin
readln(info,ch,j);
if ch='L' then addl(j) else adds(i);
end;
close(info);

writeln('Searching for labels');
repeat
b:=false;write('.');
for i:=0 to 65535 do
if sett(i) then begin
j:=i;

while (buf^[j]=$88)or(buf^[j]=$8A)do
begin if buf^[j]=$88then b:=b or addl(buf^[j+1]shl 8+buf^[j+2])
      else b:=b or adds(buf^[j+1]shl 8+buf^[j+2]);addi(j);inc(j,3);end;
j:=i;

if buf^[j-1]=$9F then dec(j);addi(j);
dec(j,3);
while (buf^[j]=$88)or(buf^[j]=$8A)do
begin if buf^[j]=$88then b:=b or addl(buf^[j+1]shl 8+buf^[j+2])
      else b:=b or adds(buf^[j+1]shl 8+buf^[j+2]);addi(j);dec(j,3);end;


end;
until not b;
for i:=0 to 8191 do instr[i]:=instr[i]or subst[i]or labels[i];
writeln(#13#10'Disassembling...');
assign(t,'seg'+char(segment+48)+'.asm');rewrite(t);
if tokinfo then begin assign(info,'seg'+char(segment+48)+'.adr');reset(info);
readln(info,j);end;
for i:=0 to 65535 do begin
if tokinfo and (j=i) then begin
readln(info,s);readln(info,j);if ioresult<>0then;
writeln(t,#13#10#13#10,'Function handling tokens: ',s);
end else
if sett(i) then begin
write(t,#13#10#13#10);
if setts(i)then writeln(t,'Subroutine: ');if settl(i)then writeln(t,'Label: ');
end;
if i and 4095 = 0then writeln(i shr 12);
pisinst(i);
end;
close(t);
end.