{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
uses database;
type tbuf=array[0..65000]of byte;
     tmapa=array[0..8191]of byte;
pbuf=^tbuf;
var i,j,k:word;
    f:file of tmapa;
    info:text;
ch:char;
var buf:pbuf;
b:boolean;
s:string;
l,segment:byte;
tokinfo:boolean;
instr,labels,subst:tmapa;
{const
unknown1:set of byte=[$0..$F,$70..$7F,$90..$9F,$E0..$EF,$FF];
jumps:set of byte =[$88,$8A,$A2,$A7,$A3,$A6];
unknown2:set of byte =[$D0..$DF];
unknown3:set of byte=[$10..$1F,$20..$2F,$30..$3F,$50..$6F,$80..$8F,$A0..$AF,$B0..$BF];
unknown4:set of byte=[$C0..$CF];}

const  conv:array[0..15]of char
      =('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function tohex(l:longint;s:byte):string;
var i:byte;
sm:string;
begin
sm:='';
for i:=1 to s do begin
sm:=conv[l and 15]+sm;
l:=l shr 4;
end;
tohex:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure load;
var f:file;
s:word;
p:string[20];
begin
p:=paramstr(1);if p[0]<>#1 then halt;
segment:=byte(p[1])-48;
if (segment>3) then halt;
tokinfo:= segment <3;
for s:=0 to 8191 do labels[s]:=0;subst:=labels;instr:=labels;
assign(f,'rom9850.rom');reset(f,1);
getmem(buf,65535);seek(f,segment*65536);
fillchar(buf^,65535,0);
blockread(f,buf^,65535,s);
close(f);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function settl(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
settl:=labels[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function setts(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
setts:=subst[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function sett(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
sett:=(labels[i] or subst[i])and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function addl(i:word):boolean;
var j:byte;
begin
addl:=false;
if settl(i)then exit;
if not setts(i) then addl:=true;
j:=i and 7;
i:=i shr 3;
labels[i]:=labels[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function adds(i:word):boolean;
var j:byte;
begin
adds:=false;
if setts(i)then exit;
if not settl(i) then adds:=true;
j:=i and 7;
i:=i shr 3;
subst[i]:=subst[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure addi(i:word);
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
instr[i]:=instr[i]or 1 shl j;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function setti(i:word):boolean;
var j:byte;
begin
j:=i and 7;
i:=i shr 3;
setti:=instr[i] and (1 shl j)<>0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
writeln('Loading ROM file');
load;
{assign(f,'seg'+char(segment+48)+'.tbl');reset(f);
read(f,labels,subst,instr);
close(f);}

writeln('Loading primary table');
if tokinfo then begin
assign(info,'seg'+char(segment+48)+'.adr');reset(info);
while not eof(info) do begin
readln(info,j);readln(info);
addl(j);
end;
close(info);
end;

writeln('Analysing exported functions');
for j:=0 to 3 do begin
write('.');
assign(info,'seg'+char(j+48)+'.exp');reset(info);
while not eof(info) do begin
readln(info,i);
if i<>segment then begin readln(info);readln(info);continue;end;
readln(info,i);
readln(info);
addl(i);
end;
close(info);
end;
writeln;


assign(info,'seg'+char(segment+48)+'.map');reset(info);
while not eof(info) do begin
readln(info,ch,j);
if ch='L' then addl(j) else adds(i);
end;
close(info);

writeln('Searching for labels');
repeat
b:=false;write('.');
for i:=0 to 65535 do
if sett(i) then begin
j:=i;

while (buf^[j]) in sicher do
begin
if isjump(buf^[j]) then
   if  buf^[j] and $F > $A then b:=b or adds(buf^[j+1]shl 8+buf^[j+2])
      else b:=b or addl(buf^[j+1]shl 8+buf^[j+2]);
      addi(j);inc(j,3);end;
end
else begin
name(buf^[j],l);inc(j,l);
end;
until not b;
writeln;
for i:=0 to 8191 do instr[i]:=instr[i]or subst[i]or labels[i];
assign(f,'seg'+char(segment+48)+'.tbl');rewrite(f);
write(f,labels,subst,instr);
close(f);

end.